
/*
This Java source file was generated by test-to-java.xsl
and is a derived work from the source document.
The source document contained the following notice:



Copyright (c) 2001-2004 World Wide Web Consortium, 
(Massachusetts Institute of Technology, Institut National de
Recherche en Informatique et en Automatique, Keio University).  All 
Rights Reserved.  This program is distributed under the W3C's Software
Intellectual Property License.  This program is distributed in the 
hope that it will be useful, but WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
PURPOSE.  

See W3C License http://www.w3.org/Consortium/Legal/ for more details.


*/

package org.w3c.domts.level3.core;

import org.w3c.dom.*;


import org.w3c.domts.DOMTestCase;
import org.w3c.domts.DOMTestDocumentBuilderFactory;



/**
 *      The method setIdAttributeNS declares the attribute specified by local name and namespace URI to be of type ID. 
 *      If the value of the specified attribute is unique then this element node can later be retrieved using getElementById on Document. 
 *      Note, however, that this simply affects this node and does not change any grammar that may be in use. 
 *      
 *      Invoke setIdAttributeNS on newly added attribute on the third strong element.  Verify by calling
 *      isID on the attribute node and getElementById on document node.
 *      Call setIdAttributeNS with isId=false to reset. Method isId should now return false. 
 *     
* @author IBM
* @author Jenny Hsu
* @see <a href="http://www.w3.org/TR/2003/CR-DOM-Level-3-Core-20031107/core#ID-ElSetIdAttrNS">http://www.w3.org/TR/2003/CR-DOM-Level-3-Core-20031107/core#ID-ElSetIdAttrNS</a>
*/
public final class elementsetidattributens04 extends DOMTestCase {

   /**
    * Constructor.
    * @param factory document factory, may not be null
    * @throws org.w3c.domts.DOMTestIncompatibleException Thrown if test is not compatible with parser configuration
    */
   public elementsetidattributens04(final DOMTestDocumentBuilderFactory factory)  throws org.w3c.domts.DOMTestIncompatibleException {

      org.w3c.domts.DocumentBuilderSetting[] settings = 
          new org.w3c.domts.DocumentBuilderSetting[] {
org.w3c.domts.DocumentBuilderSetting.namespaceAware
        };
        DOMTestDocumentBuilderFactory testFactory = factory.newInstance(settings);
        setFactory(testFactory);

    //
    //   check if loaded documents are supported for content type
    //
    String contentType = getContentType();
    preload(contentType, "hc_staff", false);
    }

   /**
    * Runs the test case.
    * @throws Throwable Any uncaught exception causes test to fail
    */
   public void runTest() throws Throwable {
      Document doc;
      NodeList elemList;
      Element strongElem;
      NamedNodeMap attributesMap;
      Attr attr;
      boolean id = false;
      Element elem;
      String elemName;
      doc = (Document) load("hc_staff", false);
      elemList = doc.getElementsByTagNameNS("*", "strong");
      strongElem = (Element) elemList.item(2);
      strongElem.setAttributeNS("http://www.netzero.com", "dmstc:newAttr", "newValue");
      strongElem.setIdAttributeNS("http://www.netzero.com", "newAttr", true);
      attributesMap = strongElem.getAttributes();
      attr = (Attr) attributesMap.getNamedItem("dmstc:newAttr");
      id = attr.isId();
      assertTrue("elementsetidattributensIsIdTrue04", id);
      elem = doc.getElementById("newValue");
      elemName = elem.getTagName();
      assertEquals("elementsetidattributensGetElementById04", "strong", elemName);
      strongElem.setIdAttributeNS("http://www.netzero.com", "newAttr", false);
      id = attr.isId();
      assertFalse("elementsetidattributensIsIdFalse04", id);
}
   /**
    *  Gets URI that identifies the test.
    *  @return uri identifier of test
    */
   public String getTargetURI() {
      return "http://www.w3.org/2001/DOM-Test-Suite/level3/core/elementsetidattributens04";
   }
   /**
    * Runs this test from the command line.
    * @param args command line arguments
    */
   public static void main(final String[] args) {
        DOMTestCase.doMain(elementsetidattributens04.class, args);
   }
}

